//
//  UMLayerCNAM.h
//  tcap-tester
//
//  Created by Andreas Fink on 05.04.16.
//  Copyright © 2017 Andreas Fink (andreas@fink.org). All rights reserved.
//

#import <ulib/ulib.h>
#import <ulibsctp/ulibsctp.h>
#import <ulibm2pa/ulibm2pa.h>
#import <ulibmtp3/ulibmtp3.h>
#import <ulibgt/ulibgt.h>
#import <ulibsccp/ulibsccp.h>
#import <ulibtcap/ulibtcap.h>
#import "UMLayerCNAMApplicationContextProtocol.h"

@interface UMLayerCNAM : UMLayer<UMTCAP_UserProtocol,UMHTTPServerHttpGetPostDelegate>
{
    UMLayerTCAP                 *tcap;
    id<UMHTTPServerHttpGetPostDelegate> webForward;
    UMSynchronizedDictionary *cnamTransactions;
    NSString *callingNumber;
    SccpSubSystemNumber *callingSsn;
    NSString *calledNumber;
    SccpSubSystemNumber *calledSsn;
    BOOL useMsisdnAsCalled;
    int callingTt;
    int calledTt;
    UMSynchronizedArray *operations;
    NSTimeInterval timeoutInSeconds;
}

@property(readwrite,strong)   UMLayerTCAP *tcap;
@property(readwrite,strong)   id<UMHTTPServerHttpGetPostDelegate> webForward;
@property(readwrite,strong)   UMSynchronizedDictionary *cnamTransactions;
@property(readwrite,assign) NSTimeInterval timeoutInSeconds;
-(UMMTP3Variant) variant;



-(void) setConfig:(NSDictionary *)cfg applicationContext:(id<UMLayerCNAMApplicationContextProtocol>)appContext;

- (UMASN1Object *)queryForGenericName:(NSString *)msisdn;

- (UMTCAP_generic_asn1_componentPDU *)processInvoke:(UMTCAP_generic_asn1_componentPDU *)component isLast:(BOOL *)isLast;
- (UMTCAP_generic_asn1_componentPDU *)processReturnResult:(UMTCAP_generic_asn1_componentPDU *)component isLast:(BOOL *)isLast;
- (UMTCAP_generic_asn1_componentPDU *)processReturnError:(UMTCAP_generic_asn1_componentPDU *)component isLast:(BOOL *)isLast;
- (UMTCAP_generic_asn1_componentPDU *)processReject:(UMTCAP_generic_asn1_componentPDU *)component isLast:(BOOL *)isLast;
- (UMTCAP_generic_asn1_componentPDU *)processComponent:(UMTCAP_generic_asn1_componentPDU *)component isLast:(BOOL *)isLast;
- (void)startUp;
@end
